## org.jfree.chart.renderer
Class AbstractRenderer

    java.lang.Object
      org.jfree.chart.renderer.AbstractRenderer

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

Direct Known Subclasses:
  AbstractCategoryItemRenderer, AbstractXYItemRenderer, DefaultPolarItemRenderer, WaferMapRenderer

    public abstract class AbstractRenderer

extends java.lang.Object
implements java.lang.Cloneable, java.io.Serializable

Base class providing common services for renderers. Most methods that update attributes of the renderer will fire a `RendererChangeEvent`, which normally means the plot that owns the renderer will receive notification that the renderer has been changed (the plot will, in turn, notify the chart).

See Also:
  Serialized Form

Field Summary
`static java.awt.Paint` `DEFAULT_OUTLINE_PAINT` The default outline paint.
`static java.awt.Stroke` `DEFAULT_OUTLINE_STROKE` The default outline stroke.
`static java.awt.Paint` `DEFAULT_PAINT` The default paint.
`static java.awt.Shape` `DEFAULT_SHAPE` The default shape.
`static java.awt.Stroke` `DEFAULT_STROKE` The default stroke.
`static java.awt.Font` `DEFAULT_VALUE_LABEL_FONT` The default value label font.
`static java.awt.Paint` `DEFAULT_VALUE_LABEL_PAINT` The default value label paint.
`static java.lang.Double` `ZERO` Zero represented as a `Double`.

Constructor Summary
`AbstractRenderer()` Default constructor.

Method Summary
`void` `addChangeListener(RendererChangeListener listener)` Registers an object to receive notification of changes to the renderer.
`protected java.awt.geom.Point2D` `calculateLabelAnchorPoint(ItemLabelAnchor anchor, double x, double y, PlotOrientation orientation)` Calculates the item label anchor point.
`protected java.lang.Object` `clone()` Returns an independent copy of the renderer.
`boolean` `equals(java.lang.Object obj)` Tests this renderer for equality with another object.
`protected void` `fireChangeEvent()` Sends a `RendererChangeEvent` to all registered listeners.
`boolean` `getAutoPopulateSeriesFillPaint()` Returns the flag that controls whether or not the series fill paint list is automatically populated when `lookupSeriesFillPaint(int)` is called.
`boolean` `getAutoPopulateSeriesOutlinePaint()` Returns the flag that controls whether or not the series outline paint list is automatically populated when `lookupSeriesOutlinePaint(int)` is called.
`boolean` `getAutoPopulateSeriesOutlineStroke()` Returns the flag that controls whether or not the series outline stroke list is automatically populated when `lookupSeriesOutlineStroke(int)` is called.
`boolean` `getAutoPopulateSeriesPaint()` Returns the flag that controls whether or not the series paint list is automatically populated when `lookupSeriesPaint(int)` is called.
`boolean` `getAutoPopulateSeriesShape()` Returns the flag that controls whether or not the series shape list is automatically populated when `lookupSeriesShape(int)` is called.
`boolean` `getAutoPopulateSeriesStroke()` Returns the flag that controls whether or not the series stroke list is automatically populated when `lookupSeriesStroke(int)` is called.
`boolean` `getBaseCreateEntities()` Returns the base visibility for all series.
`java.awt.Paint` `getBaseFillPaint()` Returns the base fill paint.
`java.awt.Font` `getBaseItemLabelFont()` Returns the base item label font (this is used when no other font setting is available).
`java.awt.Paint` `getBaseItemLabelPaint()` Returns the base item label paint.
`java.lang.Boolean` `getBaseItemLabelsVisible()` Returns the base setting for item label visibility.
`ItemLabelPosition` `getBaseNegativeItemLabelPosition()` Returns the base item label position for negative values.
`java.awt.Paint` `getBaseOutlinePaint()` Returns the base outline paint.
`java.awt.Stroke` `getBaseOutlineStroke()` Returns the base outline stroke.
`java.awt.Paint` `getBasePaint()` Returns the base paint.
`ItemLabelPosition` `getBasePositiveItemLabelPosition()` Returns the base positive item label position.
`boolean` `getBaseSeriesVisible()` Returns the base visibility for all series.
`boolean` `getBaseSeriesVisibleInLegend()` Returns the base visibility in the legend for all series.
`java.awt.Shape` `getBaseShape()` Returns the base shape.
`java.awt.Stroke` `getBaseStroke()` Returns the base stroke.
`java.lang.Boolean` `getCreateEntities()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesCreateEntities(int)` and `getBaseCreateEntities()`.
`abstract DrawingSupplier` `getDrawingSupplier()` Returns the drawing supplier from the plot.
`boolean` `getItemCreateEntity(int series, int item)` Returns a boolean that indicates whether or not the specified item should have a chart entity created for it.
`java.awt.Paint` `getItemFillPaint(int row, int column)` Returns the paint used to fill data items as they are drawn.
`double` `getItemLabelAnchorOffset()` Returns the item label anchor offset.
`java.awt.Font` `getItemLabelFont()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesItemLabelFont(int)` and `getBaseItemLabelFont()`.
`java.awt.Font` `getItemLabelFont(int row, int column)` Returns the font for an item label.
`java.awt.Paint` `getItemLabelPaint()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesItemLabelPaint(int)` and `getBaseItemLabelPaint()`.
`java.awt.Paint` `getItemLabelPaint(int row, int column)` Returns the paint used to draw an item label.
`java.awt.Paint` `getItemOutlinePaint(int row, int column)` Returns the paint used to outline data items as they are drawn.
`java.awt.Stroke` `getItemOutlineStroke(int row, int column)` Returns the stroke used to outline data items.
`java.awt.Paint` `getItemPaint(int row, int column)` Returns the paint used to fill data items as they are drawn.
`java.awt.Shape` `getItemShape(int row, int column)` Returns a shape used to represent a data item.
`java.awt.Stroke` `getItemStroke(int row, int column)` Returns the stroke used to draw data items.
`boolean` `getItemVisible(int series, int item)` Returns a boolean that indicates whether or not the specified item should be drawn (this is typically used to hide an entire series).
`ItemLabelPosition` `getNegativeItemLabelPosition()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesNegativeItemLabelPosition(int)` and `getBaseNegativeItemLabelPosition()`.
`ItemLabelPosition` `getNegativeItemLabelPosition(int row, int column)` Returns the item label position for negative values.
`ItemLabelPosition` `getPositiveItemLabelPosition()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesPositiveItemLabelPosition(int)` and `getBasePositiveItemLabelPosition()`.
`ItemLabelPosition` `getPositiveItemLabelPosition(int row, int column)` Returns the item label position for positive values.
`java.lang.Boolean` `getSeriesCreateEntities(int series)` Returns the flag that controls whether entities are created for a series.
`java.awt.Paint` `getSeriesFillPaint(int series)` Returns the paint used to fill an item drawn by the renderer.
`java.awt.Font` `getSeriesItemLabelFont(int series)` Returns the font for all the item labels in a series.
`java.awt.Paint` `getSeriesItemLabelPaint(int series)` Returns the paint used to draw the item labels for a series.
`ItemLabelPosition` `getSeriesNegativeItemLabelPosition(int series)` Returns the item label position for all negative values in a series.
`java.awt.Paint` `getSeriesOutlinePaint(int series)` Returns the paint used to outline an item drawn by the renderer.
`java.awt.Stroke` `getSeriesOutlineStroke(int series)` Returns the stroke used to outline the items in a series.
`java.awt.Paint` `getSeriesPaint(int series)` Returns the paint used to fill an item drawn by the renderer.
`ItemLabelPosition` `getSeriesPositiveItemLabelPosition(int series)` Returns the item label position for all positive values in a series.
`java.awt.Shape` `getSeriesShape(int series)` Returns a shape used to represent the items in a series.
`java.awt.Stroke` `getSeriesStroke(int series)` Returns the stroke used to draw the items in a series.
`java.lang.Boolean` `getSeriesVisible()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesVisible(int)` and `getBaseSeriesVisible()`.
`java.lang.Boolean` `getSeriesVisible(int series)` Returns the flag that controls whether a series is visible.
`java.lang.Boolean` `getSeriesVisibleInLegend()` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesVisibleInLegend(int)` and `getBaseSeriesVisibleInLegend()`.
`java.lang.Boolean` `getSeriesVisibleInLegend(int series)` Returns the flag that controls whether a series is visible in the legend.
`int` `hashCode()` Returns a hashcode for the renderer.
`boolean` `hasListener(java.util.EventListener listener)` Returns `true` if the specified object is registered with the dataset as a listener.
`boolean` `isItemLabelVisible(int row, int column)` Returns `true` if an item label is visible, and `false` otherwise.
`boolean` `isSeriesItemLabelsVisible(int series)` Returns `true` if the item labels for a series are visible, and `false` otherwise.
`boolean` `isSeriesVisible(int series)` Returns a boolean that indicates whether or not the specified series should be drawn.
`boolean` `isSeriesVisibleInLegend(int series)` Returns `true` if the series should be shown in the legend, and `false` otherwise.
`java.awt.Paint` `lookupSeriesFillPaint(int series)` Returns the paint used to fill an item drawn by the renderer.
`java.awt.Paint` `lookupSeriesOutlinePaint(int series)` Returns the paint used to outline an item drawn by the renderer.
`java.awt.Stroke` `lookupSeriesOutlineStroke(int series)` Returns the stroke used to outline the items in a series.
`java.awt.Paint` `lookupSeriesPaint(int series)` Returns the paint used to fill an item drawn by the renderer.
`java.awt.Shape` `lookupSeriesShape(int series)` Returns a shape used to represent the items in a series.
`java.awt.Stroke` `lookupSeriesStroke(int series)` Returns the stroke used to draw the items in a series.
`void` `notifyListeners(RendererChangeEvent event)` Notifies all registered listeners that the renderer has been modified.
`void` `removeChangeListener(RendererChangeListener listener)` Deregisters an object so that it no longer receives notification of changes to the renderer.
`void` `setAutoPopulateSeriesFillPaint(boolean auto)` Sets the flag that controls whether or not the series fill paint list is automatically populated when `lookupSeriesFillPaint(int)` is called.
`void` `setAutoPopulateSeriesOutlinePaint(boolean auto)` Sets the flag that controls whether or not the series outline paint list is automatically populated when `lookupSeriesOutlinePaint(int)` is called.
`void` `setAutoPopulateSeriesOutlineStroke(boolean auto)` Sets the flag that controls whether or not the series outline stroke list is automatically populated when `lookupSeriesOutlineStroke(int)` is called.
`void` `setAutoPopulateSeriesPaint(boolean auto)` Sets the flag that controls whether or not the series paint list is automatically populated when `lookupSeriesPaint(int)` is called.
`void` `setAutoPopulateSeriesShape(boolean auto)` Sets the flag that controls whether or not the series shape list is automatically populated when `lookupSeriesShape(int)` is called.
`void` `setAutoPopulateSeriesStroke(boolean auto)` Sets the flag that controls whether or not the series stroke list is automatically populated when `lookupSeriesStroke(int)` is called.
`void` `setBaseCreateEntities(boolean create)` Sets the base flag that controls whether entities are created for a series, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseCreateEntities(boolean create, boolean notify)` Sets the base flag that controls whether entities are created and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseFillPaint(java.awt.Paint paint)` Sets the base fill paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseFillPaint(java.awt.Paint paint, boolean notify)` Sets the base fill paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelFont(java.awt.Font font)` Sets the base item label font and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelFont(java.awt.Font font, boolean notify)` Sets the base item label font and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelPaint(java.awt.Paint paint)` Sets the base item label paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelPaint(java.awt.Paint paint, boolean notify)` Sets the base item label paint and, if requested, sends a `RendererChangeEvent` to all registered listeners..
`void` `setBaseItemLabelsVisible(boolean visible)` Sets the base flag that controls whether or not item labels are visible, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelsVisible(java.lang.Boolean visible)` Sets the base setting for item label visibility and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseItemLabelsVisible(java.lang.Boolean visible, boolean notify)` Sets the base visibility for item labels and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseNegativeItemLabelPosition(ItemLabelPosition position)` Sets the base item label position for negative values and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseNegativeItemLabelPosition(ItemLabelPosition position, boolean notify)` Sets the base negative item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlinePaint(java.awt.Paint paint)` Sets the base outline paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlinePaint(java.awt.Paint paint, boolean notify)` Sets the base outline paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlineStroke(java.awt.Stroke stroke)` Sets the base outline stroke and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseOutlineStroke(java.awt.Stroke stroke, boolean notify)` Sets the base outline stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBasePaint(java.awt.Paint paint)` Sets the base paint and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBasePaint(java.awt.Paint paint, boolean notify)` Sets the base paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBasePositiveItemLabelPosition(ItemLabelPosition position)` Sets the base positive item label position.
`void` `setBasePositiveItemLabelPosition(ItemLabelPosition position, boolean notify)` Sets the base positive item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseSeriesVisible(boolean visible)` Sets the base visibility and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseSeriesVisible(boolean visible, boolean notify)` Sets the base visibility and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseSeriesVisibleInLegend(boolean visible)` Sets the base visibility in the legend and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseSeriesVisibleInLegend(boolean visible, boolean notify)` Sets the base visibility in the legend and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseShape(java.awt.Shape shape)` Sets the base shape and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseShape(java.awt.Shape shape, boolean notify)` Sets the base shape and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseStroke(java.awt.Stroke stroke)` Sets the base stroke and sends a `RendererChangeEvent` to all registered listeners.
`void` `setBaseStroke(java.awt.Stroke stroke, boolean notify)` Sets the base stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setCreateEntities(java.lang.Boolean create)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesCreateEntities(int, Boolean)` and `setBaseCreateEntities(boolean)`.
`void` `setCreateEntities(java.lang.Boolean create, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelFont(int, Font, boolean)` and `setBaseItemLabelFont(Font, boolean)`.
`void` `setFillPaint(java.awt.Paint paint)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesFillPaint(int, Paint)` and `setBaseFillPaint(Paint)`.
`void` `setFillPaint(java.awt.Paint paint, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesFillPaint(int, Paint, boolean)` and `setBaseFillPaint(Paint, boolean)`.
`void` `setItemLabelAnchorOffset(double offset)` Sets the item label anchor offset.
`void` `setItemLabelFont(java.awt.Font font)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelFont(int, Font)` and `setBaseItemLabelFont(Font)`.
`void` `setItemLabelFont(java.awt.Font font, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelFont(int, Font, boolean)` and `setBaseItemLabelFont(Font, boolean)`.
`void` `setItemLabelPaint(java.awt.Paint paint)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelPaint(int, Paint)` and `setBaseItemLabelPaint(Paint)`.
`void` `setItemLabelPaint(java.awt.Paint paint, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelPaint(int, Paint, boolean)` and `setBaseItemLabelPaint(Paint, boolean)`.
`void` `setItemLabelsVisible(boolean visible)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelsVisible(int, Boolean)` and `setBaseItemLabelsVisible(boolean)`.
`void` `setItemLabelsVisible(java.lang.Boolean visible)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelsVisible(int, Boolean)` and `setBaseItemLabelsVisible(boolean)`.
`void` `setItemLabelsVisible(java.lang.Boolean visible, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelsVisible(int, Boolean, boolean)` and `setBaseItemLabelsVisible(Boolean, boolean)`.
`void` `setNegativeItemLabelPosition(ItemLabelPosition position)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesNegativeItemLabelPosition(int, ItemLabelPosition)` and `setBaseNegativeItemLabelPosition(ItemLabelPosition)`.
`void` `setNegativeItemLabelPosition(ItemLabelPosition position, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesNegativeItemLabelPosition(int, ItemLabelPosition, boolean)` and `setBaseNegativeItemLabelPosition( ItemLabelPosition, boolean)`.
`void` `setOutlinePaint(java.awt.Paint paint)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlinePaint(int, Paint)` and `setBaseOutlinePaint(Paint)`.
`void` `setOutlinePaint(java.awt.Paint paint, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlinePaint(int, Paint, boolean)` and `setBaseOutlinePaint(Paint, boolean)`.
`void` `setOutlineStroke(java.awt.Stroke stroke)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlineStroke(int, Stroke)` and `setBaseOutlineStroke(Stroke)`.
`void` `setOutlineStroke(java.awt.Stroke stroke, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlineStroke(int, Stroke, boolean)` and `setBaseOutlineStroke(Stroke, boolean)`.
`void` `setPaint(java.awt.Paint paint)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPaint(int, Paint)` and `setBasePaint(Paint)`.
`void` `setPaint(java.awt.Paint paint, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPaint(int, Paint, boolean)` and `setBasePaint(Paint, boolean)`.
`void` `setPositiveItemLabelPosition(ItemLabelPosition position)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPositiveItemLabelPosition(int, ItemLabelPosition)` and `setBasePositiveItemLabelPosition(ItemLabelPosition)`.
`void` `setPositiveItemLabelPosition(ItemLabelPosition position, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPositiveItemLabelPosition(int, ItemLabelPosition, boolean)` and `setBasePositiveItemLabelPosition( ItemLabelPosition, boolean)`.
`void` `setSeriesCreateEntities(int series, java.lang.Boolean create)` Sets the flag that controls whether entities are created for a series, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesCreateEntities(int series, java.lang.Boolean create, boolean notify)` Sets the flag that controls whether entities are created for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesFillPaint(int series, java.awt.Paint paint)` Sets the paint used for a series fill and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesFillPaint(int series, java.awt.Paint paint, boolean notify)` Sets the paint used to fill a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelFont(int series, java.awt.Font font)` Sets the item label font for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelFont(int series, java.awt.Font font, boolean notify)` Sets the item label font for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelPaint(int series, java.awt.Paint paint)` Sets the item label paint for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelPaint(int series, java.awt.Paint paint, boolean notify)` Sets the item label paint for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelsVisible(int series, boolean visible)` Sets a flag that controls the visibility of the item labels for a series, and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelsVisible(int series, java.lang.Boolean visible)` Sets the visibility of the item labels for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesItemLabelsVisible(int series, java.lang.Boolean visible, boolean notify)` Sets the visibility of item labels for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesNegativeItemLabelPosition(int series, ItemLabelPosition position)` Sets the item label position for negative values in a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesNegativeItemLabelPosition(int series, ItemLabelPosition position, boolean notify)` Sets the item label position for negative values in a series and (if requested) sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlinePaint(int series, java.awt.Paint paint)` Sets the paint used for a series outline and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlinePaint(int series, java.awt.Paint paint, boolean notify)` Sets the paint used to draw the outline for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlineStroke(int series, java.awt.Stroke stroke)` Sets the outline stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesOutlineStroke(int series, java.awt.Stroke stroke, boolean notify)` Sets the outline stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPaint(int series, java.awt.Paint paint)` Sets the paint used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPaint(int series, java.awt.Paint paint, boolean notify)` Sets the paint used for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPositiveItemLabelPosition(int series, ItemLabelPosition position)` Sets the item label position for all positive values in a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesPositiveItemLabelPosition(int series, ItemLabelPosition position, boolean notify)` Sets the item label position for all positive values in a series and (if requested) sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesShape(int series, java.awt.Shape shape)` Sets the shape used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesShape(int series, java.awt.Shape shape, boolean notify)` Sets the shape for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesStroke(int series, java.awt.Stroke stroke)` Sets the stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesStroke(int series, java.awt.Stroke stroke, boolean notify)` Sets the stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesVisible(java.lang.Boolean visible)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisible(int, Boolean)` and `setBaseSeriesVisible(boolean)`.
`void` `setSeriesVisible(java.lang.Boolean visible, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisible(int, Boolean)` and `setBaseSeriesVisible(boolean)`.
`void` `setSeriesVisible(int series, java.lang.Boolean visible)` Sets the flag that controls whether a series is visible and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesVisible(int series, java.lang.Boolean visible, boolean notify)` Sets the flag that controls whether a series is visible and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesVisibleInLegend(java.lang.Boolean visible)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisibleInLegend(int, Boolean)` and `setBaseSeriesVisibleInLegend(boolean)`.
`void` `setSeriesVisibleInLegend(java.lang.Boolean visible, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisibleInLegend(int, Boolean, boolean)` and `setBaseSeriesVisibleInLegend(boolean, boolean)`.
`void` `setSeriesVisibleInLegend(int series, java.lang.Boolean visible)` Sets the flag that controls whether a series is visible in the legend and sends a `RendererChangeEvent` to all registered listeners.
`void` `setSeriesVisibleInLegend(int series, java.lang.Boolean visible, boolean notify)` Sets the flag that controls whether a series is visible in the legend and, if requested, sends a `RendererChangeEvent` to all registered listeners.
`void` `setShape(java.awt.Shape shape)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesShape(int, Shape)` and `setBaseShape(Shape)`.
`void` `setShape(java.awt.Shape shape, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesShape(int, Shape, boolean)` and `setBaseShape(Shape, boolean)`.
`void` `setStroke(java.awt.Stroke stroke)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesStroke(int, Stroke)` and `setBaseStroke(Stroke)`.
`void` `setStroke(java.awt.Stroke stroke, boolean notify)` Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesStroke(int, Stroke, boolean)` and `setBaseStroke(Stroke, boolean)`.

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ZERO

    public static final java.lang.Double ZERO

  Zero represented as a `Double`.

### DEFAULT_PAINT

    public static final java.awt.Paint DEFAULT_PAINT

  The default paint.

### DEFAULT_OUTLINE_PAINT

    public static final java.awt.Paint DEFAULT_OUTLINE_PAINT

  The default outline paint.

### DEFAULT_STROKE

    public static final java.awt.Stroke DEFAULT_STROKE

  The default stroke.

### DEFAULT_OUTLINE_STROKE

    public static final java.awt.Stroke DEFAULT_OUTLINE_STROKE

  The default outline stroke.

### DEFAULT_SHAPE

    public static final java.awt.Shape DEFAULT_SHAPE

  The default shape.

### DEFAULT_VALUE_LABEL_FONT

    public static final java.awt.Font DEFAULT_VALUE_LABEL_FONT

  The default value label font.

### DEFAULT_VALUE_LABEL_PAINT

    public static final java.awt.Paint DEFAULT_VALUE_LABEL_PAINT

  The default value label paint.

Constructor Detail

### AbstractRenderer

    public AbstractRenderer()

  Default constructor.

Method Detail

### getDrawingSupplier

    public abstract DrawingSupplier getDrawingSupplier()

  Returns the drawing supplier from the plot.

  Returns:
    The drawing supplier.

### getItemVisible

    public boolean getItemVisible(int series,
                                  int item)

  Returns a boolean that indicates whether or not the specified item should be drawn (this is typically used to hide an entire series).

  Parameters:
    `series` - the series index.
    `item` - the item index.
  Returns:
    A boolean.

### isSeriesVisible

    public boolean isSeriesVisible(int series)

  Returns a boolean that indicates whether or not the specified series should be drawn.

  Parameters:
    `series` - the series index.
  Returns:
    A boolean.

### getSeriesVisible

    public java.lang.Boolean getSeriesVisible()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesVisible(int)` and `getBaseSeriesVisible()`.

  Returns the flag that controls the visibility of ALL series. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Returns:
    The flag (possibly `null`).
  See Also:
    `setSeriesVisible(Boolean)`

### setSeriesVisible

    public void setSeriesVisible(java.lang.Boolean visible)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisible(int, Boolean)` and `setBaseSeriesVisible(boolean)`.

  Sets the flag that controls the visibility of ALL series and sends a `RendererChangeEvent` to all registered listeners. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Parameters:
    `visible` - the flag (`null` permitted).
  See Also:
    `getSeriesVisible()`

### setSeriesVisible

    public void setSeriesVisible(java.lang.Boolean visible,
                                 boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisible(int, Boolean)` and `setBaseSeriesVisible(boolean)`.

  Sets the flag that controls the visibility of ALL series and sends a `RendererChangeEvent` to all registered listeners. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Parameters:
    `visible` - the flag (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesVisible()`

### getSeriesVisible

    public java.lang.Boolean getSeriesVisible(int series)

  Returns the flag that controls whether a series is visible.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The flag (possibly `null`).
  See Also:
    `setSeriesVisible(int, Boolean)`

### setSeriesVisible

    public void setSeriesVisible(int series,
                                 java.lang.Boolean visible)

  Sets the flag that controls whether a series is visible and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the flag (`null` permitted).
  See Also:
    `getSeriesVisible(int)`

### setSeriesVisible

    public void setSeriesVisible(int series,
                                 java.lang.Boolean visible,
                                 boolean notify)

  Sets the flag that controls whether a series is visible and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `visible` - the flag (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesVisible(int)`

### getBaseSeriesVisible

    public boolean getBaseSeriesVisible()

  Returns the base visibility for all series.

  Returns:
    The base visibility.
  See Also:
    `setBaseSeriesVisible(boolean)`

### setBaseSeriesVisible

    public void setBaseSeriesVisible(boolean visible)

  Sets the base visibility and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the flag.
  See Also:
    `getBaseSeriesVisible()`

### setBaseSeriesVisible

    public void setBaseSeriesVisible(boolean visible,
                                     boolean notify)

  Sets the base visibility and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the visibility.
    `notify` - notify listeners?
  See Also:
    `getBaseSeriesVisible()`

### isSeriesVisibleInLegend

    public boolean isSeriesVisibleInLegend(int series)

  Returns `true` if the series should be shown in the legend, and `false` otherwise.

  Parameters:
    `series` - the series index.
  Returns:
    A boolean.

### getSeriesVisibleInLegend

    public java.lang.Boolean getSeriesVisibleInLegend()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesVisibleInLegend(int)` and `getBaseSeriesVisibleInLegend()`.

  Returns the flag that controls the visibility of ALL series in the legend. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Returns:
    The flag (possibly `null`).
  See Also:
    `setSeriesVisibleInLegend(Boolean)`

### setSeriesVisibleInLegend

    public void setSeriesVisibleInLegend(java.lang.Boolean visible)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisibleInLegend(int, Boolean)` and `setBaseSeriesVisibleInLegend(boolean)`.

  Sets the flag that controls the visibility of ALL series in the legend and sends a `RendererChangeEvent` to all registered listeners. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Parameters:
    `visible` - the flag (`null` permitted).
  See Also:
    `getSeriesVisibleInLegend()`

### setSeriesVisibleInLegend

    public void setSeriesVisibleInLegend(java.lang.Boolean visible,
                                         boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesVisibleInLegend(int, Boolean, boolean)` and `setBaseSeriesVisibleInLegend(boolean, boolean)`.

  Sets the flag that controls the visibility of ALL series in the legend and sends a `RendererChangeEvent` to all registered listeners. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Parameters:
    `visible` - the flag (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesVisibleInLegend()`

### getSeriesVisibleInLegend

    public java.lang.Boolean getSeriesVisibleInLegend(int series)

  Returns the flag that controls whether a series is visible in the legend. This method returns only the "per series" settings - to incorporate the override and base settings as well, you need to use the `isSeriesVisibleInLegend(int)` method.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The flag (possibly `null`).
  See Also:
    `setSeriesVisibleInLegend(int, Boolean)`

### setSeriesVisibleInLegend

    public void setSeriesVisibleInLegend(int series,
                                         java.lang.Boolean visible)

  Sets the flag that controls whether a series is visible in the legend and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the flag (`null` permitted).
  See Also:
    `getSeriesVisibleInLegend(int)`

### setSeriesVisibleInLegend

    public void setSeriesVisibleInLegend(int series,
                                         java.lang.Boolean visible,
                                         boolean notify)

  Sets the flag that controls whether a series is visible in the legend and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `visible` - the flag (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesVisibleInLegend(int)`

### getBaseSeriesVisibleInLegend

    public boolean getBaseSeriesVisibleInLegend()

  Returns the base visibility in the legend for all series.

  Returns:
    The base visibility.
  See Also:
    `setBaseSeriesVisibleInLegend(boolean)`

### setBaseSeriesVisibleInLegend

    public void setBaseSeriesVisibleInLegend(boolean visible)

  Sets the base visibility in the legend and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the flag.
  See Also:
    `getBaseSeriesVisibleInLegend()`

### setBaseSeriesVisibleInLegend

    public void setBaseSeriesVisibleInLegend(boolean visible,
                                             boolean notify)

  Sets the base visibility in the legend and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the visibility.
    `notify` - notify listeners?
  See Also:
    `getBaseSeriesVisibleInLegend()`

### getItemPaint

    public java.awt.Paint getItemPaint(int row,
                                       int column)

  Returns the paint used to fill data items as they are drawn.

  The default implementation passes control to the `getSeriesPaint` method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The paint (never `null`).

### lookupSeriesPaint

    public java.awt.Paint lookupSeriesPaint(int series)

  Returns the paint used to fill an item drawn by the renderer.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The paint (never `null`).
  Since:
    1.0.6

### setPaint

    public void setPaint(java.awt.Paint paint)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPaint(int, Paint)` and `setBasePaint(Paint)`.

  Sets the paint to be used for ALL series, and sends a `RendererChangeEvent` to all registered listeners. If this is `null`, the renderer will use the paint for the series.

  Parameters:
    `paint` - the paint (`null` permitted).

### setPaint

    public void setPaint(java.awt.Paint paint,
                         boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPaint(int, Paint, boolean)` and `setBasePaint(Paint, boolean)`.

  Sets the paint to be used for all series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### getSeriesPaint

    public java.awt.Paint getSeriesPaint(int series)

  Returns the paint used to fill an item drawn by the renderer.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The paint (possibly `null`).
  See Also:
    `setSeriesPaint(int, Paint)`

### setSeriesPaint

    public void setSeriesPaint(int series,
                               java.awt.Paint paint)

  Sets the paint used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).
  See Also:
    `getSeriesPaint(int)`

### setSeriesPaint

    public void setSeriesPaint(int series,
                               java.awt.Paint paint,
                               boolean notify)

  Sets the paint used for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesPaint(int)`

### getBasePaint

    public java.awt.Paint getBasePaint()

  Returns the base paint.

  Returns:
    The base paint (never `null`).
  See Also:
    `setBasePaint(Paint)`

### setBasePaint

    public void setBasePaint(java.awt.Paint paint)

  Sets the base paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
  See Also:
    `getBasePaint()`

### setBasePaint

    public void setBasePaint(java.awt.Paint paint,
                             boolean notify)

  Sets the base paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - notify listeners?
  See Also:
    `getBasePaint()`

### getAutoPopulateSeriesPaint

    public boolean getAutoPopulateSeriesPaint()

  Returns the flag that controls whether or not the series paint list is automatically populated when `lookupSeriesPaint(int)` is called.

  Returns:
    A boolean.
  Since:
    1.0.6
  See Also:
    `setAutoPopulateSeriesPaint(boolean)`

### setAutoPopulateSeriesPaint

    public void setAutoPopulateSeriesPaint(boolean auto)

  Sets the flag that controls whether or not the series paint list is automatically populated when `lookupSeriesPaint(int)` is called.

  Parameters:
    `auto` - the new flag value.
  Since:
    1.0.6
  See Also:
    `getAutoPopulateSeriesPaint()`

### getItemFillPaint

    public java.awt.Paint getItemFillPaint(int row,
                                           int column)

  Returns the paint used to fill data items as they are drawn. The default implementation passes control to the `lookupSeriesFillPaint(int)` method - you can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The paint (never `null`).

### lookupSeriesFillPaint

    public java.awt.Paint lookupSeriesFillPaint(int series)

  Returns the paint used to fill an item drawn by the renderer.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The paint (never `null`).
  Since:
    1.0.6

### getSeriesFillPaint

    public java.awt.Paint getSeriesFillPaint(int series)

  Returns the paint used to fill an item drawn by the renderer.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The paint (never `null`).
  See Also:
    `setSeriesFillPaint(int, Paint)`

### setSeriesFillPaint

    public void setSeriesFillPaint(int series,
                                   java.awt.Paint paint)

  Sets the paint used for a series fill and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).
  See Also:
    `getSeriesFillPaint(int)`

### setSeriesFillPaint

    public void setSeriesFillPaint(int series,
                                   java.awt.Paint paint,
                                   boolean notify)

  Sets the paint used to fill a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesFillPaint(int)`

### setFillPaint

    public void setFillPaint(java.awt.Paint paint)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesFillPaint(int, Paint)` and `setBaseFillPaint(Paint)`.

  Sets the fill paint for ALL series (optional).

  Parameters:
    `paint` - the paint (`null` permitted).

### setFillPaint

    public void setFillPaint(java.awt.Paint paint,
                             boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesFillPaint(int, Paint, boolean)` and `setBaseFillPaint(Paint, boolean)`.

  Sets the fill paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### getBaseFillPaint

    public java.awt.Paint getBaseFillPaint()

  Returns the base fill paint.

  Returns:
    The paint (never `null`).
  See Also:
    `setBaseFillPaint(Paint)`

### setBaseFillPaint

    public void setBaseFillPaint(java.awt.Paint paint)

  Sets the base fill paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
  See Also:
    `getBaseFillPaint()`

### setBaseFillPaint

    public void setBaseFillPaint(java.awt.Paint paint,
                                 boolean notify)

  Sets the base fill paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - notify listeners?
  See Also:
    `getBaseFillPaint()`

### getAutoPopulateSeriesFillPaint

    public boolean getAutoPopulateSeriesFillPaint()

  Returns the flag that controls whether or not the series fill paint list is automatically populated when `lookupSeriesFillPaint(int)` is called.

  Returns:
    A boolean.
  Since:
    1.0.6
  See Also:
    `setAutoPopulateSeriesFillPaint(boolean)`

### setAutoPopulateSeriesFillPaint

    public void setAutoPopulateSeriesFillPaint(boolean auto)

  Sets the flag that controls whether or not the series fill paint list is automatically populated when `lookupSeriesFillPaint(int)` is called.

  Parameters:
    `auto` - the new flag value.
  Since:
    1.0.6
  See Also:
    `getAutoPopulateSeriesFillPaint()`

### getItemOutlinePaint

    public java.awt.Paint getItemOutlinePaint(int row,
                                              int column)

  Returns the paint used to outline data items as they are drawn.

  The default implementation passes control to the `lookupSeriesOutlinePaint(int)` method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The paint (never `null`).

### lookupSeriesOutlinePaint

    public java.awt.Paint lookupSeriesOutlinePaint(int series)

  Returns the paint used to outline an item drawn by the renderer.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The paint (never `null`).
  Since:
    1.0.6

### getSeriesOutlinePaint

    public java.awt.Paint getSeriesOutlinePaint(int series)

  Returns the paint used to outline an item drawn by the renderer.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The paint (possibly `null`).
  See Also:
    `setSeriesOutlinePaint(int, Paint)`

### setSeriesOutlinePaint

    public void setSeriesOutlinePaint(int series,
                                      java.awt.Paint paint)

  Sets the paint used for a series outline and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).
  See Also:
    `getSeriesOutlinePaint(int)`

### setSeriesOutlinePaint

    public void setSeriesOutlinePaint(int series,
                                      java.awt.Paint paint,
                                      boolean notify)

  Sets the paint used to draw the outline for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesOutlinePaint(int)`

### setOutlinePaint

    public void setOutlinePaint(java.awt.Paint paint)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlinePaint(int, Paint)` and `setBaseOutlinePaint(Paint)`.

  Sets the outline paint for ALL series (optional) and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).

### setOutlinePaint

    public void setOutlinePaint(java.awt.Paint paint,
                                boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlinePaint(int, Paint, boolean)` and `setBaseOutlinePaint(Paint, boolean)`.

  Sets the outline paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).
    `notify` - notify listeners?

### getBaseOutlinePaint

    public java.awt.Paint getBaseOutlinePaint()

  Returns the base outline paint.

  Returns:
    The paint (never `null`).
  See Also:
    `setBaseOutlinePaint(Paint)`

### setBaseOutlinePaint

    public void setBaseOutlinePaint(java.awt.Paint paint)

  Sets the base outline paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
  See Also:
    `getBaseOutlinePaint()`

### setBaseOutlinePaint

    public void setBaseOutlinePaint(java.awt.Paint paint,
                                    boolean notify)

  Sets the base outline paint and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - notify listeners?
  See Also:
    `getBaseOutlinePaint()`

### getAutoPopulateSeriesOutlinePaint

    public boolean getAutoPopulateSeriesOutlinePaint()

  Returns the flag that controls whether or not the series outline paint list is automatically populated when `lookupSeriesOutlinePaint(int)` is called.

  Returns:
    A boolean.
  Since:
    1.0.6
  See Also:
    `setAutoPopulateSeriesOutlinePaint(boolean)`

### setAutoPopulateSeriesOutlinePaint

    public void setAutoPopulateSeriesOutlinePaint(boolean auto)

  Sets the flag that controls whether or not the series outline paint list is automatically populated when `lookupSeriesOutlinePaint(int)` is called.

  Parameters:
    `auto` - the new flag value.
  Since:
    1.0.6
  See Also:
    `getAutoPopulateSeriesOutlinePaint()`

### getItemStroke

    public java.awt.Stroke getItemStroke(int row,
                                         int column)

  Returns the stroke used to draw data items.

  The default implementation passes control to the getSeriesStroke method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The stroke (never `null`).

### lookupSeriesStroke

    public java.awt.Stroke lookupSeriesStroke(int series)

  Returns the stroke used to draw the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The stroke (never `null`).
  Since:
    1.0.6

### setStroke

    public void setStroke(java.awt.Stroke stroke)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesStroke(int, Stroke)` and `setBaseStroke(Stroke)`.

  Sets the stroke for ALL series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).

### setStroke

    public void setStroke(java.awt.Stroke stroke,
                          boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesStroke(int, Stroke, boolean)` and `setBaseStroke(Stroke, boolean)`.

  Sets the stroke for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?

### getSeriesStroke

    public java.awt.Stroke getSeriesStroke(int series)

  Returns the stroke used to draw the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The stroke (possibly `null`).
  See Also:
    `setSeriesStroke(int, Stroke)`

### setSeriesStroke

    public void setSeriesStroke(int series,
                                java.awt.Stroke stroke)

  Sets the stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `stroke` - the stroke (`null` permitted).
  See Also:
    `getSeriesStroke(int)`

### setSeriesStroke

    public void setSeriesStroke(int series,
                                java.awt.Stroke stroke,
                                boolean notify)

  Sets the stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesStroke(int)`

### getBaseStroke

    public java.awt.Stroke getBaseStroke()

  Returns the base stroke.

  Returns:
    The base stroke (never `null`).
  See Also:
    `setBaseStroke(Stroke)`

### setBaseStroke

    public void setBaseStroke(java.awt.Stroke stroke)

  Sets the base stroke and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).
  See Also:
    `getBaseStroke()`

### setBaseStroke

    public void setBaseStroke(java.awt.Stroke stroke,
                              boolean notify)

  Sets the base stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).
    `notify` - notify listeners?
  See Also:
    `getBaseStroke()`

### getAutoPopulateSeriesStroke

    public boolean getAutoPopulateSeriesStroke()

  Returns the flag that controls whether or not the series stroke list is automatically populated when `lookupSeriesStroke(int)` is called.

  Returns:
    A boolean.
  Since:
    1.0.6
  See Also:
    `setAutoPopulateSeriesStroke(boolean)`

### setAutoPopulateSeriesStroke

    public void setAutoPopulateSeriesStroke(boolean auto)

  Sets the flag that controls whether or not the series stroke list is automatically populated when `lookupSeriesStroke(int)` is called.

  Parameters:
    `auto` - the new flag value.
  Since:
    1.0.6
  See Also:
    `getAutoPopulateSeriesStroke()`

### getItemOutlineStroke

    public java.awt.Stroke getItemOutlineStroke(int row,
                                                int column)

  Returns the stroke used to outline data items. The default implementation passes control to the `lookupSeriesOutlineStroke(int)` method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The stroke (never `null`).

### lookupSeriesOutlineStroke

    public java.awt.Stroke lookupSeriesOutlineStroke(int series)

  Returns the stroke used to outline the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The stroke (never `null`).
  Since:
    1.0.6

### setOutlineStroke

    public void setOutlineStroke(java.awt.Stroke stroke)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlineStroke(int, Stroke)` and `setBaseOutlineStroke(Stroke)`.

  Sets the outline stroke for ALL series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).

### setOutlineStroke

    public void setOutlineStroke(java.awt.Stroke stroke,
                                 boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesOutlineStroke(int, Stroke, boolean)` and `setBaseOutlineStroke(Stroke, boolean)`.

  Sets the outline stroke for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?

### getSeriesOutlineStroke

    public java.awt.Stroke getSeriesOutlineStroke(int series)

  Returns the stroke used to outline the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The stroke (possibly `null`).
  See Also:
    `setSeriesOutlineStroke(int, Stroke)`

### setSeriesOutlineStroke

    public void setSeriesOutlineStroke(int series,
                                       java.awt.Stroke stroke)

  Sets the outline stroke used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `stroke` - the stroke (`null` permitted).
  See Also:
    `getSeriesOutlineStroke(int)`

### setSeriesOutlineStroke

    public void setSeriesOutlineStroke(int series,
                                       java.awt.Stroke stroke,
                                       boolean notify)

  Sets the outline stroke for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `stroke` - the stroke (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesOutlineStroke(int)`

### getBaseOutlineStroke

    public java.awt.Stroke getBaseOutlineStroke()

  Returns the base outline stroke.

  Returns:
    The stroke (never `null`).
  See Also:
    `setBaseOutlineStroke(Stroke)`

### setBaseOutlineStroke

    public void setBaseOutlineStroke(java.awt.Stroke stroke)

  Sets the base outline stroke and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).
  See Also:
    `getBaseOutlineStroke()`

### setBaseOutlineStroke

    public void setBaseOutlineStroke(java.awt.Stroke stroke,
                                     boolean notify)

  Sets the base outline stroke and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `stroke` - the stroke (`null` not permitted).
    `notify` - a flag that controls whether or not listeners are notified.
  See Also:
    `getBaseOutlineStroke()`

### getAutoPopulateSeriesOutlineStroke

    public boolean getAutoPopulateSeriesOutlineStroke()

  Returns the flag that controls whether or not the series outline stroke list is automatically populated when `lookupSeriesOutlineStroke(int)` is called.

  Returns:
    A boolean.
  Since:
    1.0.6
  See Also:
    `setAutoPopulateSeriesOutlineStroke(boolean)`

### setAutoPopulateSeriesOutlineStroke

    public void setAutoPopulateSeriesOutlineStroke(boolean auto)

  Sets the flag that controls whether or not the series outline stroke list is automatically populated when `lookupSeriesOutlineStroke(int)` is called.

  Parameters:
    `auto` - the new flag value.
  Since:
    1.0.6
  See Also:
    `getAutoPopulateSeriesOutlineStroke()`

### getItemShape

    public java.awt.Shape getItemShape(int row,
                                       int column)

  Returns a shape used to represent a data item.

  The default implementation passes control to the getSeriesShape method. You can override this method if you require different behaviour.

  Parameters:
    `row` - the row (or series) index (zero-based).
    `column` - the column (or category) index (zero-based).
  Returns:
    The shape (never `null`).

### lookupSeriesShape

    public java.awt.Shape lookupSeriesShape(int series)

  Returns a shape used to represent the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The shape (never `null`).
  Since:
    1.0.6

### setShape

    public void setShape(java.awt.Shape shape)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesShape(int, Shape)` and `setBaseShape(Shape)`.

  Sets the shape for ALL series (optional) and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` permitted).

### setShape

    public void setShape(java.awt.Shape shape,
                         boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesShape(int, Shape, boolean)` and `setBaseShape(Shape, boolean)`.

  Sets the shape for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` permitted).
    `notify` - notify listeners?

### getSeriesShape

    public java.awt.Shape getSeriesShape(int series)

  Returns a shape used to represent the items in a series.

  Parameters:
    `series` - the series (zero-based index).
  Returns:
    The shape (possibly `null`).
  See Also:
    `setSeriesShape(int, Shape)`

### setSeriesShape

    public void setSeriesShape(int series,
                               java.awt.Shape shape)

  Sets the shape used for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `shape` - the shape (`null` permitted).
  See Also:
    `getSeriesShape(int)`

### setSeriesShape

    public void setSeriesShape(int series,
                               java.awt.Shape shape,
                               boolean notify)

  Sets the shape for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero based).
    `shape` - the shape (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesShape(int)`

### getBaseShape

    public java.awt.Shape getBaseShape()

  Returns the base shape.

  Returns:
    The shape (never `null`).
  See Also:
    `setBaseShape(Shape)`

### setBaseShape

    public void setBaseShape(java.awt.Shape shape)

  Sets the base shape and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` not permitted).
  See Also:
    `getBaseShape()`

### setBaseShape

    public void setBaseShape(java.awt.Shape shape,
                             boolean notify)

  Sets the base shape and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `shape` - the shape (`null` not permitted).
    `notify` - notify listeners?
  See Also:
    `getBaseShape()`

### getAutoPopulateSeriesShape

    public boolean getAutoPopulateSeriesShape()

  Returns the flag that controls whether or not the series shape list is automatically populated when `lookupSeriesShape(int)` is called.

  Returns:
    A boolean.
  Since:
    1.0.6
  See Also:
    `setAutoPopulateSeriesShape(boolean)`

### setAutoPopulateSeriesShape

    public void setAutoPopulateSeriesShape(boolean auto)

  Sets the flag that controls whether or not the series shape list is automatically populated when `lookupSeriesShape(int)` is called.

  Parameters:
    `auto` - the new flag value.
  Since:
    1.0.6
  See Also:
    `getAutoPopulateSeriesShape()`

### isItemLabelVisible

    public boolean isItemLabelVisible(int row,
                                      int column)

  Returns `true` if an item label is visible, and `false` otherwise.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column index (zero-based).
  Returns:
    A boolean.

### isSeriesItemLabelsVisible

    public boolean isSeriesItemLabelsVisible(int series)

  Returns `true` if the item labels for a series are visible, and `false` otherwise.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    A boolean.

### setItemLabelsVisible

    public void setItemLabelsVisible(boolean visible)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelsVisible(int, Boolean)` and `setBaseItemLabelsVisible(boolean)`.

  Sets the visibility of the item labels for ALL series.

  Parameters:
    `visible` - the flag.

### setItemLabelsVisible

    public void setItemLabelsVisible(java.lang.Boolean visible)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelsVisible(int, Boolean)` and `setBaseItemLabelsVisible(boolean)`.

  Sets the visibility of the item labels for ALL series (optional).

  Parameters:
    `visible` - the flag (`null` permitted).

### setItemLabelsVisible

    public void setItemLabelsVisible(java.lang.Boolean visible,
                                     boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelsVisible(int, Boolean, boolean)` and `setBaseItemLabelsVisible(Boolean, boolean)`.

  Sets the visibility of item labels for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - a flag that controls whether or not the item labels are visible (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### setSeriesItemLabelsVisible

    public void setSeriesItemLabelsVisible(int series,
                                           boolean visible)

  Sets a flag that controls the visibility of the item labels for a series, and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the flag.

### setSeriesItemLabelsVisible

    public void setSeriesItemLabelsVisible(int series,
                                           java.lang.Boolean visible)

  Sets the visibility of the item labels for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the flag (`null` permitted).

### setSeriesItemLabelsVisible

    public void setSeriesItemLabelsVisible(int series,
                                           java.lang.Boolean visible,
                                           boolean notify)

  Sets the visibility of item labels for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `visible` - the visible flag.
    `notify` - a flag that controls whether or not listeners are notified.

### getBaseItemLabelsVisible

    public java.lang.Boolean getBaseItemLabelsVisible()

  Returns the base setting for item label visibility. A `null` result should be interpreted as equivalent to `Boolean.FALSE`.

  Returns:
    A flag (possibly `null`).
  See Also:
    `setBaseItemLabelsVisible(boolean)`

### setBaseItemLabelsVisible

    public void setBaseItemLabelsVisible(boolean visible)

  Sets the base flag that controls whether or not item labels are visible, and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the flag.
  See Also:
    `getBaseItemLabelsVisible()`

### setBaseItemLabelsVisible

    public void setBaseItemLabelsVisible(java.lang.Boolean visible)

  Sets the base setting for item label visibility and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the flag (`null` is permitted, and viewed as equivalent to `Boolean.FALSE`).

### setBaseItemLabelsVisible

    public void setBaseItemLabelsVisible(java.lang.Boolean visible,
                                         boolean notify)

  Sets the base visibility for item labels and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `visible` - the flag (`null` is permitted, and viewed as equivalent to `Boolean.FALSE`).
    `notify` - a flag that controls whether or not listeners are notified.
  See Also:
    `getBaseItemLabelsVisible()`

### getItemLabelFont

    public java.awt.Font getItemLabelFont(int row,
                                          int column)

  Returns the font for an item label.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column index (zero-based).
  Returns:
    The font (never `null`).

### getItemLabelFont

    public java.awt.Font getItemLabelFont()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesItemLabelFont(int)` and `getBaseItemLabelFont()`.

  Returns the font used for all item labels. This may be `null`, in which case the per series font settings will apply.

  Returns:
    The font (possibly `null`).

### setItemLabelFont

    public void setItemLabelFont(java.awt.Font font)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelFont(int, Font)` and `setBaseItemLabelFont(Font)`.

  Sets the item label font for ALL series and sends a `RendererChangeEvent` to all registered listeners. You can set this to `null` if you prefer to set the font on a per series basis.

  Parameters:
    `font` - the font (`null` permitted).

### setItemLabelFont

    public void setItemLabelFont(java.awt.Font font,
                                 boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelFont(int, Font, boolean)` and `setBaseItemLabelFont(Font, boolean)`.

  Sets the item label font for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `font` - the font (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.

### getSeriesItemLabelFont

    public java.awt.Font getSeriesItemLabelFont(int series)

  Returns the font for all the item labels in a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The font (possibly `null`).
  See Also:
    `setSeriesItemLabelFont(int, Font)`

### setSeriesItemLabelFont

    public void setSeriesItemLabelFont(int series,
                                       java.awt.Font font)

  Sets the item label font for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `font` - the font (`null` permitted).
  See Also:
    `getSeriesItemLabelFont(int)`

### setSeriesItemLabelFont

    public void setSeriesItemLabelFont(int series,
                                       java.awt.Font font,
                                       boolean notify)

  Sets the item label font for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero based).
    `font` - the font (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.
  See Also:
    `getSeriesItemLabelFont(int)`

### getBaseItemLabelFont

    public java.awt.Font getBaseItemLabelFont()

  Returns the base item label font (this is used when no other font setting is available).

  Returns:
    The font (`never` null).
  See Also:
    `setBaseItemLabelFont(Font)`

### setBaseItemLabelFont

    public void setBaseItemLabelFont(java.awt.Font font)

  Sets the base item label font and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `font` - the font (`null` not permitted).
  See Also:
    `getBaseItemLabelFont()`

### setBaseItemLabelFont

    public void setBaseItemLabelFont(java.awt.Font font,
                                     boolean notify)

  Sets the base item label font and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `font` - the font (`null` not permitted).
    `notify` - a flag that controls whether or not listeners are notified.
  See Also:
    `getBaseItemLabelFont()`

### getItemLabelPaint

    public java.awt.Paint getItemLabelPaint(int row,
                                            int column)

  Returns the paint used to draw an item label.

  Parameters:
    `row` - the row index (zero based).
    `column` - the column index (zero based).
  Returns:
    The paint (never `null`).

### getItemLabelPaint

    public java.awt.Paint getItemLabelPaint()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesItemLabelPaint(int)` and `getBaseItemLabelPaint()`.

  Returns the paint used for all item labels. This may be `null`, in which case the per series paint settings will apply.

  Returns:
    The paint (possibly `null`).

### setItemLabelPaint

    public void setItemLabelPaint(java.awt.Paint paint)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelPaint(int, Paint)` and `setBaseItemLabelPaint(Paint)`.

  Sets the item label paint for ALL series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` permitted).

### setItemLabelPaint

    public void setItemLabelPaint(java.awt.Paint paint,
                                  boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelPaint(int, Paint, boolean)` and `setBaseItemLabelPaint(Paint, boolean)`.

  Sets the item label paint for ALL series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint.
    `notify` - a flag that controls whether or not listeners are notified.

### getSeriesItemLabelPaint

    public java.awt.Paint getSeriesItemLabelPaint(int series)

  Returns the paint used to draw the item labels for a series.

  Parameters:
    `series` - the series index (zero based).
  Returns:
    The paint (possibly `null`).``
  See Also:
    `setSeriesItemLabelPaint(int, Paint)`

### setSeriesItemLabelPaint

    public void setSeriesItemLabelPaint(int series,
                                        java.awt.Paint paint)

  Sets the item label paint for a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series (zero based index).
    `paint` - the paint (`null` permitted).
  See Also:
    `getSeriesItemLabelPaint(int)`

### setSeriesItemLabelPaint

    public void setSeriesItemLabelPaint(int series,
                                        java.awt.Paint paint,
                                        boolean notify)

  Sets the item label paint for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero based).
    `paint` - the paint (`null` permitted).
    `notify` - a flag that controls whether or not listeners are notified.
  See Also:
    `getSeriesItemLabelPaint(int)`

### getBaseItemLabelPaint

    public java.awt.Paint getBaseItemLabelPaint()

  Returns the base item label paint.

  Returns:
    The paint (never `null`).``
  See Also:
    `setBaseItemLabelPaint(Paint)`

### setBaseItemLabelPaint

    public void setBaseItemLabelPaint(java.awt.Paint paint)

  Sets the base item label paint and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `paint` - the paint (`null` not permitted).
  See Also:
    `getBaseItemLabelPaint()`

### setBaseItemLabelPaint

    public void setBaseItemLabelPaint(java.awt.Paint paint,
                                      boolean notify)

  Sets the base item label paint and, if requested, sends a `RendererChangeEvent` to all registered listeners..

  Parameters:
    `paint` - the paint (`null` not permitted).
    `notify` - a flag that controls whether or not listeners are notified.
  See Also:
    `getBaseItemLabelPaint()`

### getPositiveItemLabelPosition

    public ItemLabelPosition getPositiveItemLabelPosition(int row,
                                                          int column)

  Returns the item label position for positive values.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column index (zero-based).
  Returns:
    The item label position (never `null`).
  See Also:
    `getNegativeItemLabelPosition(int, int)`

### getPositiveItemLabelPosition

    public ItemLabelPosition getPositiveItemLabelPosition()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesPositiveItemLabelPosition(int)` and `getBasePositiveItemLabelPosition()`.

  Returns the item label position for positive values in ALL series.

  Returns:
    The item label position (possibly `null`).
  See Also:
    `setPositiveItemLabelPosition(ItemLabelPosition)`

### setPositiveItemLabelPosition

    public void setPositiveItemLabelPosition(ItemLabelPosition position)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPositiveItemLabelPosition(int, ItemLabelPosition)` and `setBasePositiveItemLabelPosition(ItemLabelPosition)`.

  Sets the item label position for positive values in ALL series, and sends a `RendererChangeEvent` to all registered listeners. You need to set this to `null` to expose the settings for individual series.

  Parameters:
    `position` - the position (`null` permitted).
  See Also:
    `getPositiveItemLabelPosition()`

### setPositiveItemLabelPosition

    public void setPositiveItemLabelPosition(ItemLabelPosition position,
                                             boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesPositiveItemLabelPosition(int, ItemLabelPosition, boolean)` and `setBasePositiveItemLabelPosition( ItemLabelPosition, boolean)`.

  Sets the positive item label position for ALL series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?
  See Also:
    `getPositiveItemLabelPosition()`

### getSeriesPositiveItemLabelPosition

    public ItemLabelPosition getSeriesPositiveItemLabelPosition(int series)

  Returns the item label position for all positive values in a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The item label position (never `null`).
  See Also:
    `setSeriesPositiveItemLabelPosition(int, ItemLabelPosition)`

### setSeriesPositiveItemLabelPosition

    public void setSeriesPositiveItemLabelPosition(int series,
                                                   ItemLabelPosition position)

  Sets the item label position for all positive values in a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).
  See Also:
    `getSeriesPositiveItemLabelPosition(int)`

### setSeriesPositiveItemLabelPosition

    public void setSeriesPositiveItemLabelPosition(int series,
                                                   ItemLabelPosition position,
                                                   boolean notify)

  Sets the item label position for all positive values in a series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?
  See Also:
    `getSeriesPositiveItemLabelPosition(int)`

### getBasePositiveItemLabelPosition

    public ItemLabelPosition getBasePositiveItemLabelPosition()

  Returns the base positive item label position.

  Returns:
    The position (never `null`).
  See Also:
    `setBasePositiveItemLabelPosition(ItemLabelPosition)`

### setBasePositiveItemLabelPosition

    public void setBasePositiveItemLabelPosition(ItemLabelPosition position)

  Sets the base positive item label position.

  Parameters:
    `position` - the position (`null` not permitted).
  See Also:
    `getBasePositiveItemLabelPosition()`

### setBasePositiveItemLabelPosition

    public void setBasePositiveItemLabelPosition(ItemLabelPosition position,
                                                 boolean notify)

  Sets the base positive item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` not permitted).
    `notify` - notify registered listeners?
  See Also:
    `getBasePositiveItemLabelPosition()`

### getNegativeItemLabelPosition

    public ItemLabelPosition getNegativeItemLabelPosition(int row,
                                                          int column)

  Returns the item label position for negative values. This method can be overridden to provide customisation of the item label position for individual data items.

  Parameters:
    `row` - the row index (zero-based).
    `column` - the column (zero-based).
  Returns:
    The item label position (never `null`).
  See Also:
    `getPositiveItemLabelPosition(int, int)`

### getNegativeItemLabelPosition

    public ItemLabelPosition getNegativeItemLabelPosition()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesNegativeItemLabelPosition(int)` and `getBaseNegativeItemLabelPosition()`.

  Returns the item label position for negative values in ALL series.

  Returns:
    The item label position (possibly `null`).
  See Also:
    `setNegativeItemLabelPosition(ItemLabelPosition)`

### setNegativeItemLabelPosition

    public void setNegativeItemLabelPosition(ItemLabelPosition position)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesNegativeItemLabelPosition(int, ItemLabelPosition)` and `setBaseNegativeItemLabelPosition(ItemLabelPosition)`.

  Sets the item label position for negative values in ALL series, and sends a `RendererChangeEvent` to all registered listeners. You need to set this to `null` to expose the settings for individual series.

  Parameters:
    `position` - the position (`null` permitted).
  See Also:
    `getNegativeItemLabelPosition()`

### setNegativeItemLabelPosition

    public void setNegativeItemLabelPosition(ItemLabelPosition position,
                                             boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesNegativeItemLabelPosition(int, ItemLabelPosition, boolean)` and `setBaseNegativeItemLabelPosition( ItemLabelPosition, boolean)`.

  Sets the item label position for negative values in ALL series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?
  See Also:
    `getNegativeItemLabelPosition()`

### getSeriesNegativeItemLabelPosition

    public ItemLabelPosition getSeriesNegativeItemLabelPosition(int series)

  Returns the item label position for all negative values in a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The item label position (never `null`).
  See Also:
    `setSeriesNegativeItemLabelPosition(int, ItemLabelPosition)`

### setSeriesNegativeItemLabelPosition

    public void setSeriesNegativeItemLabelPosition(int series,
                                                   ItemLabelPosition position)

  Sets the item label position for negative values in a series and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).
  See Also:
    `getSeriesNegativeItemLabelPosition(int)`

### setSeriesNegativeItemLabelPosition

    public void setSeriesNegativeItemLabelPosition(int series,
                                                   ItemLabelPosition position,
                                                   boolean notify)

  Sets the item label position for negative values in a series and (if requested) sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `position` - the position (`null` permitted).
    `notify` - notify registered listeners?
  See Also:
    `getSeriesNegativeItemLabelPosition(int)`

### getBaseNegativeItemLabelPosition

    public ItemLabelPosition getBaseNegativeItemLabelPosition()

  Returns the base item label position for negative values.

  Returns:
    The position (never `null`).
  See Also:
    `setBaseNegativeItemLabelPosition(ItemLabelPosition)`

### setBaseNegativeItemLabelPosition

    public void setBaseNegativeItemLabelPosition(ItemLabelPosition position)

  Sets the base item label position for negative values and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` not permitted).
  See Also:
    `getBaseNegativeItemLabelPosition()`

### setBaseNegativeItemLabelPosition

    public void setBaseNegativeItemLabelPosition(ItemLabelPosition position,
                                                 boolean notify)

  Sets the base negative item label position and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `position` - the position (`null` not permitted).
    `notify` - notify registered listeners?
  See Also:
    `getBaseNegativeItemLabelPosition()`

### getItemLabelAnchorOffset

    public double getItemLabelAnchorOffset()

  Returns the item label anchor offset.

  Returns:
    The offset.
  See Also:
    `setItemLabelAnchorOffset(double)`

### setItemLabelAnchorOffset

    public void setItemLabelAnchorOffset(double offset)

  Sets the item label anchor offset.

  Parameters:
    `offset` - the offset.
  See Also:
    `getItemLabelAnchorOffset()`

### getItemCreateEntity

    public boolean getItemCreateEntity(int series,
                                       int item)

  Returns a boolean that indicates whether or not the specified item should have a chart entity created for it.

  Parameters:
    `series` - the series index.
    `item` - the item index.
  Returns:
    A boolean.

### getCreateEntities

    public java.lang.Boolean getCreateEntities()

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `getSeriesCreateEntities(int)` and `getBaseCreateEntities()`.

  Returns the flag that controls whether or not chart entities are created for the items in ALL series. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Returns:
    The flag (possibly `null`).

### setCreateEntities

    public void setCreateEntities(java.lang.Boolean create)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesCreateEntities(int, Boolean)` and `setBaseCreateEntities(boolean)`.

  Sets the flag that controls whether or not chart entities are created for the items in ALL series, and sends a `RendererChangeEvent` to all registered listeners. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Parameters:
    `create` - the flag (`null` permitted).

### setCreateEntities

    public void setCreateEntities(java.lang.Boolean create,
                                  boolean notify)

  Deprecated. This method should no longer be used (as of version 1.0.6). It is sufficient to rely on `setSeriesItemLabelFont(int, Font, boolean)` and `setBaseItemLabelFont(Font, boolean)`.

  Sets the flag that controls whether or not chart entities are created for the items in ALL series, and sends a `RendererChangeEvent` to all registered listeners. This flag overrides the per series and default settings - you must set it to `null` if you want the other settings to apply.

  Parameters:
    `create` - the flag (`null` permitted).
    `notify` - notify listeners?

### getSeriesCreateEntities

    public java.lang.Boolean getSeriesCreateEntities(int series)

  Returns the flag that controls whether entities are created for a series.

  Parameters:
    `series` - the series index (zero-based).
  Returns:
    The flag (possibly `null`).
  See Also:
    `setSeriesCreateEntities(int, Boolean)`

### setSeriesCreateEntities

    public void setSeriesCreateEntities(int series,
                                        java.lang.Boolean create)

  Sets the flag that controls whether entities are created for a series, and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index (zero-based).
    `create` - the flag (`null` permitted).
  See Also:
    `getSeriesCreateEntities(int)`

### setSeriesCreateEntities

    public void setSeriesCreateEntities(int series,
                                        java.lang.Boolean create,
                                        boolean notify)

  Sets the flag that controls whether entities are created for a series and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `series` - the series index.
    `create` - the flag (`null` permitted).
    `notify` - notify listeners?
  See Also:
    `getSeriesCreateEntities(int)`

### getBaseCreateEntities

    public boolean getBaseCreateEntities()

  Returns the base visibility for all series.

  Returns:
    The base visibility.
  See Also:
    `setBaseCreateEntities(boolean)`

### setBaseCreateEntities

    public void setBaseCreateEntities(boolean create)

  Sets the base flag that controls whether entities are created for a series, and sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `create` - the flag.
  See Also:
    `getBaseCreateEntities()`

### setBaseCreateEntities

    public void setBaseCreateEntities(boolean create,
                                      boolean notify)

  Sets the base flag that controls whether entities are created and, if requested, sends a `RendererChangeEvent` to all registered listeners.

  Parameters:
    `create` - the visibility.
    `notify` - notify listeners?
  See Also:
    `getBaseCreateEntities()`

### calculateLabelAnchorPoint

    protected java.awt.geom.Point2D calculateLabelAnchorPoint(ItemLabelAnchor anchor,
                                                              double x,
                                                              double y,
                                                              PlotOrientation orientation)

  Calculates the item label anchor point.

  Parameters:
    `anchor` - the anchor.
    `x` - the x coordinate.
    `y` - the y coordinate.
    `orientation` - the plot orientation.
  Returns:
    The anchor point (never `null`).

### addChangeListener

    public void addChangeListener(RendererChangeListener listener)

  Registers an object to receive notification of changes to the renderer.

  Parameters:
    `listener` - the listener (`null` not permitted).
  See Also:
    `removeChangeListener(RendererChangeListener)`

### removeChangeListener

    public void removeChangeListener(RendererChangeListener listener)

  Deregisters an object so that it no longer receives notification of changes to the renderer.

  Parameters:
    `listener` - the object (`null` not permitted).
  See Also:
    `addChangeListener(RendererChangeListener)`

### hasListener

    public boolean hasListener(java.util.EventListener listener)

  Returns `true` if the specified object is registered with the dataset as a listener. Most applications won't need to call this method, it exists mainly for use by unit testing code.

  Parameters:
    `listener` - the listener.
  Returns:
    A boolean.

### fireChangeEvent

    protected void fireChangeEvent()

  Sends a `RendererChangeEvent` to all registered listeners.

  Since:
    1.0.5

### notifyListeners

    public void notifyListeners(RendererChangeEvent event)

  Notifies all registered listeners that the renderer has been modified.

  Parameters:
    `event` - information about the change event.

### equals

    public boolean equals(java.lang.Object obj)

  Tests this renderer for equality with another object.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object (`null` permitted).
  Returns:
    `true` or `false`.

### hashCode

    public int hashCode()

  Returns a hashcode for the renderer.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    The hashcode.

### clone

    protected java.lang.Object clone()
                              throws java.lang.CloneNotSupportedException

  Returns an independent copy of the renderer.

  Overrides:
    `clone` in class `java.lang.Object`
  Returns:
    A clone.
  Throws:
    `java.lang.CloneNotSupportedException` - if some component of the renderer does not support cloning.